<?php
/*
Plugin Name: Visual Composer Quform Integration
Plugin URI: http://amansaini.me
Description: Extend Visual Composer option to insert any form created by Quform
Version: 0.1
Author: Aman Saini
Author URI:  http://amansaini.me
License: GPLv2 or later
*/

/*

This Plugin lets you choose the created Quform form to insert into the page content directly via Visual Composer.
*/

// don't load directly
if (!defined('ABSPATH')) die('-1');

/*
Display notice if Visual Composer is not installed or activated.
*/


if ( !defined('WPB_VC_VERSION') ) { add_action('admin_notices', 'vc_quform_extend_notice'); return; }
function vc_quform_extend_notice() {
  $plugin_data = get_plugin_data(__FILE__);
  echo '
  <div class="updated">
    <p>'.sprintf(__('<strong>%s</strong> requires <strong><a href="http://bit.ly/vcomposer" target="_blank">Visual Composer</a></strong> plugin to be installed and activated on your site.', 'vc_extend'), $plugin_data['Name']).'</p>
  </div>';
}





/**
 * Check if the Quform is active and add the shortcode option into visual composer if Quform is active
 */


if ( defined('IPHORM_VERSION') ) {
  $quforms_array[__("No Quforms found.", "js_composer")] = '';
    $quforms = iphorm_get_all_forms();
    if ($quforms) {

     $quforms_array = array(__("Select a form to display.", "js_composer") => '');
      foreach ( $quforms as $quform ) {
         $quforms_array[$quform['name']]= $quform['id'];
      }
    }

  vc_map( array(
    "name" => __("Quform", "js_composer"),
    "base" => "iphorm",
    "icon" => "icon-wpb-vc_quform",
    "category" => __("Content", "js_composer"),
    "description" => __('Place Quform', 'js_composer'),
    "admin_enqueue_css" => array(plugins_url('vc_extend_quform-admin.css', __FILE__)),
    "params" => array(
      array(
        "type" => "dropdown",
        "heading" => __("Form", "js_composer"),
        "param_name" => "id",
        "value" => $quforms_array,
        "description" => __("Select a form to add it to your post or page.", "js_composer"),
        "admin_label" => true
      )

    )
  ) );
} // if Quform Forms active



